#include "STC8H.H"
#include "define.h"
#include "stc32_stc8_usb.h"
#include <intrins.h>
#include <stdio.h>
#include <string.h>

#define		MAIN_Fosc	22118400UL   //ʱ
#define		ADC_SPEED	15			/* 0~15, ADCתʱ(CPUʱ) = (n+1)*32  ADCCFG */
#define		RES_FMT		(1<<5)		/* ADCʽ 0: , ADC_RES: D11 D10 D9 D8 D7 D6 D5 D4, ADC_RESL: D3 D2 D1 D0 0 0 0 0 */
									/* ADCCFG     1: Ҷ, ADC_RES: 0 0 0 0 D11 D10 D9 D8, ADC_RESL: D7 D6 D5 D4 D3 D2 D1 D0 */
#define		ADC_CH		2			/* 1~16, ADCתͨ, ͬ޸ DMA_ADC_CHSW תͨ */
#define		ADC_NUM		256			/* ÿͨADCת, ͬ޸DMA_ADC_CFG2 ת */
#define		DMA_ADDR	0x800		/* DMAݴŵַ */

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";	//ԶλISPûӿ

bit	Dma_Flag;
unsigned long ADC_Value[ADC_CH];
unsigned char xdata CDC_Buffer[10];
unsigned char xdata DMA_Buffer[ADC_CH][ADC_NUM*2+4] _at_ DMA_ADDR;

void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=MAIN_Fosc/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

BOOL usb_OUT_callback()
{
//	USB_SendData(UsbOutBuffer,OutNumber);
	return 1;
}

void Init(void)
{
	P_SW2|=0x80;	//չĴ(XFR)ʹ
	P0M0=0x00; P0M1=0x00; 
	P1M0=0x00; P1M1=0x03; 
	P2M0=0x00; P2M1=0x00; 
	P3M0=0x00; P3M1=0x00; 
	P4M0=0x00; P4M1=0x00; 
	P5M0=0x00; P5M1=0x00; 
	P6M0=0x00; P6M1=0x00; 
	P7M0=0x00; P7M1=0x00; 
	
	P3M0&=~0x03;
	P3M1|=0x03;
	IRC48MCR=0x80;
	while(!(IRC48MCR&0x01));
	USBCLK=0x00;
	USBCON=0x90;
	usb_init();
	IE2|=0x80;			//IE2صжλʹܺҪEUSB
	
	ADCTIM=0x3f;		//ͨѡʱ䡢ʱ䡢ʱ
	ADCCFG=RES_FMT+ADC_SPEED;
	ADC_CONTR=0x80+0;	//ADC on + channel
	
	DMA_ADC_STA=0x00;
	DMA_ADC_CFG=0x80;	//bit7 1:Enable Interrupt
	DMA_ADC_RXAH=(unsigned char)(DMA_ADDR>>8);	//ADCתݴ洢ַ
	DMA_ADC_RXAL=(unsigned char)DMA_ADDR;
	DMA_ADC_CFG2=0x0F;	//ÿͨADCת:256
	DMA_ADC_CHSW0=0x03;	//ADCͨʹܼĴ ADC7~ADC0
	DMA_ADC_CHSW1=0x00;	//ADCͨʹܼĴ ADC15~ADC8
	DMA_ADC_CR=0xc0;	//bit7 1:Enable ADC_DMA, bit6 1:Start ADC_DMA
	
    EA=1;
	memset(CDC_Buffer,0x00,sizeof CDC_Buffer);
}

void main(void)
{
	unsigned char i;
	unsigned long value;
	Init();
	while(1)
	{
		if(DeviceState!=DEVSTATE_CONFIGURED)  //ȴUSB
            continue;
		Delay_ms(10);
		if(Dma_Flag)
		{
			Dma_Flag=0;
			for(i=0;i<ADC_CH;i++)
			{
				ADC_Value[i]=DMA_Buffer[i][2*ADC_NUM+2];
				ADC_Value[i]<<=8;
				ADC_Value[i]|=DMA_Buffer[i][2*ADC_NUM+3];
				ADC_Value[i]<<=8;
				ADC_Value[i]|=DMA_Buffer[i][2*ADC_NUM+1];
				ADC_Value[i]>>=4;	//20bit4λ16λ
			}
			
//			CDC_Buffer[0]=(ADC_Value[0]%10000000/1000000)|0x30;
//			CDC_Buffer[1]=(ADC_Value[0]%1000000/100000)|0x30;
//			CDC_Buffer[2]=(ADC_Value[0]%100000/10000)|0x30;
//			CDC_Buffer[3]=(ADC_Value[0]%10000/1000)|0x30;
//			CDC_Buffer[4]=(ADC_Value[0]%1000/100)|0x30;
//			CDC_Buffer[5]=(ADC_Value[0]%100/10)|0x30;
//			CDC_Buffer[6]=(ADC_Value[0]%10)|0x30;
//			CDC_Buffer[7]=0x0d;
//			CDC_Buffer[8]=0x0a;
//			USB_SendData(CDC_Buffer,9);	//ʮʾ
			
			value=ADC_Value[0];
			value=value*500/65536;
			CDC_Buffer[0]=value>>8;
			CDC_Buffer[1]=value;
			USB_SendData(CDC_Buffer,2);	//ڻͼ
			
			DMA_ADC_CR=0xc0;	//bit7 1:Enable ADC_DMA, bit6 1:Start ADC_DMA
		}
	}
}

void DMA_ADC_Isr(void) interrupt 13	//ӳж
{
	DMA_ADC_STA=0;
	Dma_Flag=1;
}